"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var MqlContext_1 = __importDefault(require("../../context/MqlContext/MqlContext"));
var CreateMqlQuery_1 = __importDefault(require("../../mutations/mql/CreateMqlQuery"));
var clearEmptyConstraints_1 = __importDefault(require("./clearEmptyConstraints"));
var useMqlQuery_1 = require("../useMqlQuery");
var getErrorMessage_1 = __importDefault(require("./getErrorMessage"));
var useCreateMqlQuery = function (_a) {
    var metricName = _a.metricName, formState = _a.formState, dispatch = _a.dispatch, state = _a.state, retries = _a.retries;
    var _b = react_1.useContext(MqlContext_1.default), useQuery = _b.useQuery, useMutation = _b.useMutation, handleCombinedError = _b.handleCombinedError, mqlServerUrl = _b.mqlServerUrl;
    var _c = useMutation(CreateMqlQuery_1.default), _d = _c[0], createMqlQuery = _c[1];
    var doCreateMqlQuery = function (_a) {
        var stateRetries = _a.stateRetries;
        console.log('createMQLQuery');
        createMqlQuery({
            metrics: [metricName],
            groupBy: formState.groupBy || [],
            where: clearEmptyConstraints_1.default(formState.where),
            pctChange: formState.pctChange,
            timeGranularity: formState.timeGranularity,
            granularity: formState.granularity,
            addTimeSeries: true,
            startTime: formState.startTime,
            endTime: formState.endTime,
            order: formState.order,
            limit: formState.limit,
            daysLimit: formState.daysLimit
        }).then(function (_a) {
            var _b, _c;
            var data = _a.data, error = _a.error;
            // if (data?.createMqlQuery?.query?.status === MqlQueryStatus.Successful) {
            //   dispatch({
            //     type: "postQueryCachedResultsSuccess",
            //     data,
            //     handleCombinedError,
            //   });
            // } else {
            if ((_b = data === null || data === void 0 ? void 0 : data.createMqlQuery) === null || _b === void 0 ? void 0 : _b.id) {
                dispatch({
                    type: "postQuerySuccess",
                    queryId: (_c = data === null || data === void 0 ? void 0 : data.createMqlQuery) === null || _c === void 0 ? void 0 : _c.id,
                });
            }
            else if (error) {
                if (retries > 0 && stateRetries !== retries && stateRetries < retries) {
                    setTimeout(function () {
                        dispatch({ type: "retryFetchResults" });
                        doCreateMqlQuery({ stateRetries: state.retries + 1 });
                    }, useMqlQuery_1.RETRY_POLLING_MS);
                }
                else {
                    dispatch({
                        type: "postQueryFail",
                        errorMessage: getErrorMessage_1.default(error),
                    });
                }
                handleCombinedError(error);
            }
            // }
        });
    };
    return {
        doCreateMqlQuery: doCreateMqlQuery
    };
};
exports.default = useCreateMqlQuery;
